chiark / gitweb /
Avoid use of "my $_", which is not portable
[dgit.git] / tests / lib
index 5caa4c31c49d87c76152ab4dc0ddef240e11f6f2..22ae0ff5052a9f349319fc22ffec6ea09b8f1eff 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -2,13 +2,14 @@
 
 exec 2>&1
 set -x
+set -o pipefail
 
-if [ "x$DGIT_TEST_INTREE" != x ]; then
-       : ${DGIT_TEST:=$DGIT_TEST_INTREE/dgit}
-       : ${DGIT_REPOS_SERVER_TEST:=$DGIT_TEST_INTREE/infra/dgit-repos-server}
-       : ${DGIT_SSH_DISPATCH_TEST:=$DGIT_TEST_INTREE/infra/dgit-ssh-dispatch}
-       export DGIT_TEST DGIT_REPOS_SERVER_TEST DGIT_SSH_DISPATCH_TEST
-fi
+. tests/lib-core
+
+t-set-intree
+
+: ${DGIT_TEST_DEBUG:=-D}
+export DGIT_TEST_DEBUG
 
 root=`pwd`
 troot=$root/tests
@@ -22,16 +23,16 @@ if [ x"$tmp" = x ]; then
        mkdir $tmp
 fi
 cd $tmp
-export HOME=$tmp
 
 tmp=`pwd`
-export DGIT_TEST_DUMMY_DIR=$tmp
+
+t-set-using-tmp
+
 ln -f $troot/ssh ssh
 
 mkdir -p $tmp/gnupg
 cp $troot/gnupg/* $tmp/gnupg
 chmod go-rw $tmp/gnupg/*
-export GNUPGHOME=$tmp/gnupg
 
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
@@ -41,9 +42,73 @@ incoming             = $tmp/incoming
 run_dinstall           = 0
 END
 
-fail () {
-       echo >&2 "failed: $*"
-       exit 1
+t-expect-fail () {
+       local mpat="$1"; shift
+
+       local grepper=fgrep
+       case "$mpat" in
+       [A-Z]:*)
+               case "$mpat" in
+               E:*)    grepper=egrep   ;;
+               F:*)    grepper=fgrep   ;;
+               *)      fail "bad mpat prefix in $mpat";;
+               esac
+               mpat=${mpat#[A-Z]:}
+               ;;
+       esac
+
+       set +o pipefail
+       LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
+       local ps="${PIPESTATUS[*]}"
+       set -o pipefail
+
+       case $ps in
+       "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
+       *" 0")  ;;
+       *)      fail "tee failed"  ;;
+       esac
+
+       $grepper -e "$mpat" $tmp/t.output ||
+               fail "error message not found"
+}
+
+t-expect-push-fail () {
+       local mpat="$1"; shift
+
+       local triedpush=`git rev-parse HEAD`
+
+       t-reporefs pre-push
+       t-expect-fail "$mpat"  "$@"
+       t-reporefs post-push
+       diff $tmp/show-refs.{pre,post}-push
+
+       t-git-objects-not-present '' $triedpush
+
+       eval "$t_expect_push_fail_hook"
+}
+
+t-git-objects-not-present () {
+       # t-git-objects-not-present GITDIR|'' OBJID [...]
+       # specifying '' means the repo for package $p
+       local gitdir="${1-$tmp/git/$p.git}"
+       local obj
+       if ! [ -e "$gitdir" ]; then return; fi
+       for obj in "$@"; do
+               GIT_DIR=$gitdir \
+               t-expect-fail 'unable to find' \
+               git cat-file -t $obj
+       done
+}
+
+t-reporefs () {
+       local whichoutput=$1; shift
+       local outputfile="$tmp/show-refs.$whichoutput"
+       (set -e
+        exec >"$outputfile"
+        if test -d $tmp/git/$p.git; then
+               cd $tmp/git/$p.git
+               git show-ref |sort
+       fi)
 }
 
 t-untar () {
@@ -81,34 +146,124 @@ t-has-ancestor () {
        if [ x$mbase != x$ancestor ]; then
                fail "not ff $ancestor..$now, $mbase != $ancestor"
        fi
-}      
+}
+
+t-prep-newpackage () {
+       p=$1
+       v=$2
+       t-archive-none $p
+       t-git-none
+       t-worktree $v
+       cd $p
+       if ! git-show-ref --verify --quiet refs/heads/master; then
+               git branch -m dgit/sid master
+               git remote rm dgit
+       fi
+       cd ..
+}
 
 t-archive-none () {
        p=$1
-       mkdir -p $tmp/aq $tmp/mirror/main
-       echo sid >$tmp/aq/suite.unstable
+       mkdir -p $tmp/aq $tmp/mirror/pool/main
+
+       local suite=sid
+
+       >$tmp/aq/package.$suite.$p
+       t-archive-updated $suite $p
+
+       >$tmp/aq/package.new.$p
+       t-archive-updated new $p
+
+       ln -s sid $tmp/aq/dsc_in_suite/unstable
+       cat <<'END' >$tmp/aq/suites
+[
+   {
+      "archive" : "ftp-master",
+      "codename" : "sid",
+      "components" : [
+         "main",
+         "contrib",
+         "non-free"
+      ],
+      "name" : "unstable",
+      "dakname" : "unstable"
+   }
+]
+END
+}
+
+t-archive-updated () {
+       local suite=$1
+       local p=$2
+       local suitedir=$tmp/aq/dsc_in_suite/$suite
+       mkdir -p $suitedir
+       perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
+               use JSON;
+               use strict;
+               our @v;
+               m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
+               push @v, {
+                       "version" => "$1",
+                       "sha256sum" => "$2",
+                       "component" => "$3",
+                       "filename" => "$4",
+               };
+               END {
+                       print to_json \@v or die $!;
+               }
+       '
 }
 
 t-archive-process-incoming () {
-       mv incoming/${p}_${v}[._]* mirror/main/
-       t-archive-query
+       local suite=$1
+       mv $tmp/incoming/${p}_${v}[._]* $tmp/mirror/pool/main/
+       t-archive-query "$suite"
 }
 
 t-archive-query () {
-       local dscf=${p}_${v}.dsc
-       echo "${v} main/$dscf" >>$tmp/aq/package.sid.${p}
+       local suite=${1-sid}
+       local dscf=main/${p}_${v}.dsc
+       local sha=`sha256sum <$tmp/mirror/pool/$dscf`
+       echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
+       t-archive-updated $suite $p
 }
 
 t-archive () {
        t-archive-none $1
        v=$2
        local dscf=${p}_$2.dsc
-       rm -f $tmp/mirror/main/${p}_*
-       ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/main/
+       rm -f $tmp/mirror/pool/main/${p}_*
+       ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
        t-archive-query
        rm -rf $tmp/extract
        mkdir $tmp/extract
-       (set -e; cd $tmp/extract; dpkg-source -x ../mirror/main/$dscf)
+       (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
+}
+
+t-git-dir-time-passes () {
+       touch -d 'last year' $tmp/git/$p.git
+}
+
+t-git-dir-check () {
+       local gitdir=$tmp/git/$p.git
+       case "$1" in
+       enoent)
+               if test -e "$gitdir"; then fail "$gitdir exists"; fi
+               return
+               ;;
+       public) wantstat='7[75]5' ;;
+       secret) wantstat='7[70]0' ;;
+       *)      fail "$1 t-git-dir-check ?" ;;
+       esac
+       gotstat=`stat -c%a $gitdir`
+       case "$gotstat" in
+       *$wantstat) return ;;
+       *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
+       esac
+}
+
+t-rm-dput-dropping () {
+       rm -f $tmp/${p}_${v}_*.upload
 }
 
 t-dgit () {
@@ -116,7 +271,7 @@ t-dgit () {
        : '
 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
        $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
-               -dtest-dummy $DGIT_TEST_OPTS ${DGIT_TEST_DEBUG--D} \
+               -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
                -k39B13D8A "$@"
        : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
 '
@@ -133,7 +288,7 @@ t-cloned-fetched-good () {
        t-refs-same \
                refs/heads/dgit/sid \
                refs/remotes/dgit/dgit/sid
-       t-refs-notexist dgit/unstable remotes/dgit/dgit/unstable
+       t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
 }
 
 t-output () {
@@ -147,9 +302,23 @@ t-clean-on-branch () {
        t-output "## $1" git status -b --porcelain
 }
 
+t-git-get-ref-exact () {
+       local ref=$1
+       # does not dereference, unlike t-git-get-ref
+       case "$ref" in
+       refs/*) ;;
+       *) fail "t-git-get-ref-exact bad $ref" ;;
+       esac
+       git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
+}
+
 t-git-get-ref () {
        local ref=$1
-       git show-ref -d $1 | perl -ne '
+       case "$ref" in
+       refs/*) ;;
+       *) fail "t-git-get-ref bad $ref" ;;
+       esac
+       (git show-ref -d $1 || test $? = 1) | perl -ne '
                $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
                END { print "$x\n" if length $x; }
        '
@@ -235,6 +404,44 @@ t-822-field () {
        ' <$file
 }
 
+t-stunt-envvar () {
+       local var=$1
+       local tstunt=$2
+       eval '
+               case "'$var'" in
+               "$tstunt:"*)    ;;
+               *":$tstunt:"*)  ;;
+               *)              '$var'="$tstunt:$'$var'" ;;
+               esac
+       '
+}
+
+t-tstunt () {
+       local tstunt=$tmp/tstunt
+       t-stunt-envvar PATH $tstunt
+       t-stunt-envvar PERLLIB $tstunt
+       local f
+       for f in "$@"; do
+               f="./$f"
+               local d="$tstunt/${f%/*}"
+               mkdir -p $d
+               ln -sf "$troot/tstunt/$f" "$d"/.
+       done
+}
+
+t-tstunt-parsechangelog () {
+       t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
+}
+
+t-prep-mergechangelogs () {
+       local b=merge.dpkg-mergechangelogs
+       git config $b.name 'debian/changelog merge driver'
+       git config $b.driver 'dpkg-mergechangelogs -m %O %A %B %A'
+       mkdir -p .git/info
+       echo >>.git/info/attributes \
+               'debian/changelog merge=dpkg-mergechangelogs'
+}
+
 t-ref-dsc-dgit () {
        local dsc=${p}_${v}.dsc
        local val=`t-822-field $tmp/incoming/$dsc Dgit`
@@ -245,8 +452,18 @@ t-ref-dsc-dgit () {
 t-apply-diff () {
        local v1=$1
        local v2=$2
-       (cd $troot/pkg-srcs; debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc) \
-               | patch -p1 -u
+       (cd $troot/pkg-srcs;
+        debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
+        | patch -p1 -u
+}
+
+t-commit () {
+       local msg=$1
+       v=1.$revision
+       dch -v$v --distribution unstable "$1"
+       git add debian/changelog
+       debcommit
+       revision=$(( $revision + 1 ))
 }
 
 t-git-config () {
@@ -255,12 +472,25 @@ t-git-config () {
 
 t-drs () {
        export DGIT_TEST_TROOT=$troot
-       export DGIT_TEST_TMP=$tmp
  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
  t-git-config dgit-distro.test-dummy.git-check true
  t-git-config dgit-distro.test-dummy.git-create true
-       cp $root/tests/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
-       cp $root/tests/suites $tmp/.
+       cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
+       cp $troot/suites $tmp/.
+
+       drs_dispatch=$tmp/distro=test-dummy
+       mkdir $drs_dispatch
+
+       if [ "x$DGIT_TEST_INTREE" != x ]; then
+               ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
+       fi
+
+       ln -sf $tmp/git $drs_dispatch/repos
+       ln -sf $tmp/suites $tmp/dm.txt $drs_dispatch/
+       mkdir -p $drs_dispatch/keyrings
+       ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
+       ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
+       ln -sf /bin/true $drs_dispatch/policy-hook
 }
 
 t-dsd () {
@@ -277,17 +507,30 @@ t-dsd () {
  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
 
-       dsd_dispatch=$tmp/dispatch-dir/distro=test-dummy
-       mkdir -p $dsd_dispatch
-       ln -sf $root $dsd_dispatch/dgit-live
-       ln -sf $tmp/git $dsd_dispatch/repos
-       ln -sf $tmp/suites $tmp/dm.txt $dsd_dispatch/
-       mkdir -p $dsd_dispatch/keyrings
-       ln -sf $tmp/dd.gpg $dsd_dispatch/keyrings/debian-keyring.gpg
-       ln -sf $tmp/dm.gpg $dsd_dispatch/keyrings/debian-maintainers.gpg
-       ln -sf /bin/true $dsd_dispatch/policy-hook
-
-       echo 'no-such-package* drs' >$dsd_dispatch/diverts
+       echo 'no-such-package* drs' >$drs_dispatch/diverts
+}
+
+t-policy-admin () {
+       ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
+}
+
+t-policy () {
+       local policyhook=$1
+       ln -sf ${DGIT_INFRA_PFX}$policyhook \
+               $drs_dispatch/policy-hook
+}
+
+t-debpolicy () {
+       t-dsd
+       t-policy dgit-repos-policy-debian
+
+       mkdir $tmp/git
+       t-policy-admin create-db
+}
+
+t-policy-periodic () {
+       ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
+               test-dummy $drs_dispatch '' --cron
 }
 
 t-chain-test () {